;
; Disassembled standard MBR code           Part of the MATTsoft Boot Manager
;    - commented by mhi -                    http://penguin.cz/~mhi/mbtmgr/
;

;==========================================================================
boot		segment	byte public
		assume cs:boot  , ds:boot

start:		cli				; Disable interrupts
		sub	ax,ax
		mov	ss,ax
		mov	es,ax
		mov	ds,ax
		mov	ax,7C00h
		mov	sp,ax
		sti				; Enable interrupts

		mov	si,ax
		mov	di,7E00h
		cld				; Clear direction
		mov	cx,100h			; 0x100 words, == 512 bytes
		rep	movsw			; Move to new location
		jmp	$+203h 			; (0:7E00)

		;-[this is executed at new location]
		mov	cx,10h
		mov	si,ds:7e85h		; first partition item

next_item:	;-[scan for active partition]--
		test	byte ptr [si],80h	; is it active partition?
		jnz	activefound		; Yes, I found it.
		sub	si,10h			; next item
		loop	next_item		; ...

		jmp	short loc_8

		nop

		;-[prepare for disk_read]------
activefound:	mov	di,7beh			; buffer at 0:7be
		push	di			; save di
		mov	cx,8			; 8 bytes
		rep	movsw			; copy 8 bytes from active p.
		pop	si			; restore si

		mov	bx,7c00h		; Load at 0:7c00
		mov	dx,[si]			; head+drive
		mov	cx,[si+2]		; cyl+sector

		;-[load sector from disk]-------
		mov	bp,5			; tries count
disk_read:	mov	ax,201h			; function=2(read), 1 sector
		int	13h			; Read sector from disk
		jnc	boot_it			; If no error, go boot
		sub	ax,ax			; ax = 0, reset function.
		int	13h			; Reset hard-disk
		dec	bp
		jz	loc_9			; Jump if zero
		jmp	short disk_read

		;-[jump to boot sector]--------
boot_it:	mov	si,7dfeh		; last two bytes, magic no
		lodsw				; Get it!
		cmp	ax,0AA55h		; Is it 0xAA55 ?
		jne	loc_10			; No, invalid boot
		mov	si,7beh			; Historical reasons...
		jmp	0000:7c00		; And jump to boot sectors

;============================================================================
; Display error messages and halt system

loc_8:		mov	si,ds:err0
		jmp	short print

loc_9:		mov	si,ds:err1
		jmp	short print

loc_10:		mov	si,ds:err2
		; this will continue in 'print'

;=============================================================================
; Display message at ds:si and halt system

print:
		lodsb				; Get next char
		or	al,al			; End of string?
halt:		jz	halt			; Yes, halt system
		mov	bx,7			; attribute
		mov	ah,0Eh			; video function
		int	10h			; Display it
		jmp	short print		; loop next char

;=============================================================================
; Error messages

ofs0	dw mess0
ofs1	dw mess1
ofs2	dw mess2

mess0	db 0Dh, 0Ah, 'Invalid Partition Table', 0
mess1	db 0Dh, 0Ah, 'Error Loading Operating System', 0
mess2	db 0Dh, 0Ah, 'Missing Operating System', 0

	db 25 dup (0)			; 0
	db 0AAh, 55h			; magic? WHY!
	db 192 dup (0)			; 0

boot0	db 80h				; Yes, it is bootable partition
s_head0 db 00h				; Start head
s_sec0	db 02h				; Start sec
s_cyl0	db 00h				; Start cyl
sys0	db 54h				; DM ontrack
e_head0	db 0Eh				; End head
e_sec0	db 3Fh				; End sec.
e_cyl0	db 0Eh				; End cyl.
start0	dd 1				; Start linear sector
count0	dd C02B5Eh			; size in sectors

	db	49 dup (0)		; rest is free, no partitions
magic	db	 55h,0AAh

boot		ends
		end
;============================================================================
